# Coursera Specialization

## Google IT Automation With Python

Learn in-demand skills like Python, Git, and IT automation to advance my career

### What Was Learned

- Automate tasks by writing Python scripts
- Use Git and GitHub for version control
- Manage IT resources at scale, both for physical machines and virtual machines in the cloud 
- Analyze real-world IT problems and implement the appropriate strategies to solve those problems

### Skills Obtained

- Using Version Control
- Using Version Control
- Python Programming
- Configuration Management
- Automation
- Basic Python Data Structures
- Fundamental Programming Concepts
- Basic Python Syntax
- Object-Oriented Programming (OOP)
- Setting up your Development Environment
- Regular Expression (REGEX)
- Testing in Python

## About Professional Certificate

This is beginner-level, six-course certificate, developed by Google, is designed to provide IT professionals with 
in-demand skills -- including Python, Git, and IT automation -- that can help me advance my career. Knowing how to write
code to solve problems and automate solutions is a crucial skill for anybody in IT. Python, in particular,
is now the [most in-demand programming language by employers](https://insights.dice.com/2019/10/08/python-java-top-languages-employers/).

This program builds on your IT foundations to help you take a career to the next level. It’s designed to teach one
how to program with Python and how to use Python to automate common system administration tasks. Learned to
use Git and GitHub, troubleshoot and debug complex problems, and apply automation at scale by using configuration 
management and the Cloud.

This certificate can be completed in about 6 months and is designed to prepare one for a variety of roles in IT, like 
more advanced IT Support Specialist or Junior Systems Administrator positions. Upon completion, one can share his/her 
information with potential employers, like Walmart, Sprint, Hulu, Bank of America, Google (of course!), and more.

### Applied Learning Project

- Learn how to program with Python with no previous knowledge of coding required and use Python to automate 
  common system administration tasks.
- Learn to use Git and GitHub, to troubleshoot and debug complex problems.
- Apply automation at scale by using configuration management and the Cloud.
- Practice your technical skills with hands-on projects including a capstone project where one will use neyourw knowledge 
  to solve a real-world IT problem.

## Associated Courses

### 1. [Crash Course On Python](https://www.coursera.org/learn/python-crash-course?specialization=google-it-automation)

This course is designed to teach one the foundations in order to write simple programs in Python using the most common 
structures. No previous exposure to programming is needed. By the end of this course, one will understand the benefits of 
programming in IT roles; be able to write simple programs using Python; figure out how the building blocks of programming
fit together; and combine all of this knowledge to solve a complex programming problem. 

Course starts off by diving into the basics of writing a computer program. Along the way, one gets hands-on experience
with programming concepts through interactive exercises and real-world examples. One will quickly start to see how 
computers can perform a multitude of tasks — one will just have to write code that tells them what to do.

### 2. [Using Python to Interact with the Operating System](https://www.coursera.org/learn/python-operating-system?specialization=google-it-automation)

By the end of this course, one will be able to manipulate files and processes on one's computer’s operating system.
Will have learned about regular expressions -- a very powerful tool for processing text files -- and would have gotten
some practice using the Linux command line on a virtual machine. And, this might feel like a stretch right now, but
one will also write a program that processes a bunch of errors in an actual log file and then generates a summary file.
That’s a super useful skill for IT Specialists to know.
