## Practice Quiz: Strings

### Question 1

The `is_palindrome` function checks if a string is a palindrome. A palindrome is a string that can be equally read from 
left to right or right to left, omitting blank spaces, and ignoring capitalization. Examples of palindromes are words 
like kayak and radar, and phrases like "Never Odd or Even". Fill in the blanks in this function to return True if the 
passed string is a palindrome, False if not.

**Solution**:

```python
def is_palindrome(input_string: str) -> None:
	# We'll create two strings, to compare them
	new_string = ""
	reverse_string = ""
	# Traverse through each letter of the input string
	for letter in input_string.lower():
		# Add any non-blank letters to the 
		# end of one string, and to the front
		# of the other string. 
		if len(letter) > 0 and not letter.isspace():
			new_string = f"{new_string}{letter}"
			reverse_string = f"{letter}{reverse_string}"
	return new_string == reverse_string

print(is_palindrome("Never Odd or Even")) # Should be True
print(is_palindrome("abc")) # Should be False
print(is_palindrome("kayak")) # Should be True
```

### Question 2

Using the format method, fill in the gaps in the `convert_distance` function so that it returns the phrase "X miles 
equals Y km", with Y having only 1 decimal place. For example, convert_distance(12) should return "12 miles equals 
19.2 km".

**Solution**:

```python
def convert_distance(miles):
	km = miles * 1.6 
	result = "{} miles equals {:.1f} km".format(miles, km)
	return result

print(convert_distance(12)) # Should be: 12 miles equals 19.2 km
print(convert_distance(5.5)) # Should be: 5.5 miles equals 8.8 km
print(convert_distance(11)) # Should be: 11 miles equals 17.6 km
```

### Question 4

Fill in the gaps in the `nametag` function so that it uses the format method to return `first_name` and the first initial 
of `last_name` followed by a period. For example, `nametag("Jane", "Smith")` should return "Jane S."

**Solution**:

```python
def nametag(first_name, last_name):
    return "{} {}.".format(first_name, last_name[0])


print(nametag("Jane", "Smith"))
# Should display "Jane S." 
print(nametag("Francesco", "Rinaldi"))
# Should display "Francesco R." 
print(nametag("Jean-Luc", "Grand-Pierre"))
# Should display "Jean-Luc G." 
```

### Question 5

The `replace_ending` function replaces the old string in a sentence replace_endingwith the new string, but only if the 
sentence ends with the old string. If there is more than one occurrence of replace_endingthe old string in the sentence, 
only the one at the end is replaced, not all of them. For example, `replace_ending("abcabc", "abc", "xyz")` should 
return abcxyz, not xyzxyz or xyzabc. The string comparison is case-sensitive, so `replace_ending("abcabc", "ABC", "xyz")` 
should return abcabc (no changes made). 

```python
def replace_ending(sentence, old, new):
	if sentence.endswith(old):
		old_last_idx = sentence.rindex(old)
		return sentence[0:old_last_idx] + new + sentence[old_last_idx + len(old):]
	return sentence
	
print(replace_ending("It's raining cats and cats", "cats", "dogs")) 
# Should display "It's raining cats and dogs"
print(replace_ending("She sells seashells by the seashore", "seashells", "donuts")) 
# Should display "She sells seashells by the seashore"
print(replace_ending("The weather is nice in May", "may", "april")) 
# Should display "The weather is nice in May"
print(replace_ending("The weather is nice in May", "May", "April")) 
# Should display "The weather is nice in April"
```
